<?php
/**
 * Health Coach Services functions and definitions
 *
 * @package Health Coach Services
 */

if ( ! defined( 'HEALTH_COACH_SERVICES_VERSION' ) ) {
	// Replace the version number of the theme on each release.
	define( 'HEALTH_COACH_SERVICES_VERSION', '1.0.0' );
}

function health_coach_services_setup() {

	load_theme_textdomain( 'health-coach-services', get_template_directory() . '/languages' );

	add_theme_support( 'automatic-feed-links' );
	add_theme_support( 'title-tag' );
	add_theme_support( 'post-thumbnails' );
	add_theme_support( 'woocommerce' );
	add_theme_support( "align-wide" );
	add_theme_support( "responsive-embeds" );

	register_nav_menus(
		array(
			'menu-1' => esc_html__( 'Primary', 'health-coach-services' ),
			'social-menu' => esc_html__('Social Menu', 'health-coach-services'),
		)
	);

	add_theme_support(
		'html5',
		array(
			'search-form',
			'comment-form',
			'comment-list',
			'gallery',
			'caption',
			'style',
			'script',
		)
	);

	add_theme_support(
		'custom-background',
		apply_filters(
			'health_coach_services_custom_background_args',
			array(
				'default-color' => '#fafafa',
				'default-image' => '',
			)
		)
	);

	add_theme_support( 'customize-selective-refresh-widgets' );

	add_theme_support(
		'custom-logo',
		array(
			'height'      => 250,
			'width'       => 250,
			'flex-width'  => true,
			'flex-height' => true,
		)
	);

    add_theme_support( 'post-formats', array(
        'image',
        'video',
        'gallery',
        'audio', 
    ));
	
}
add_action( 'after_setup_theme', 'health_coach_services_setup' );

/**
 * Set the content width in pixels, based on the theme's design and stylesheet.
 *
 * Priority 0 to make it available to lower priority callbacks.
 *
 * @global int $content_width
 */
function health_coach_services_content_width() {
	$GLOBALS['content_width'] = apply_filters( 'health_coach_services_content_width', 640 );
}
add_action( 'after_setup_theme', 'health_coach_services_content_width', 0 );

add_filter( 'woocommerce_enable_setup_wizard', '__return_false' );

/**
 * Register widget area.
 *
 * @link https://developer.wordpress.org/themes/functionality/sidebars/#registering-a-sidebar
 */
function health_coach_services_widgets_init() {
	register_sidebar(
		array(
			'name'          => esc_html__( 'Sidebar', 'health-coach-services' ),
			'id'            => 'sidebar-1',
			'description'   => esc_html__( 'Add widgets here.', 'health-coach-services' ),
			'before_widget' => '<section id="%1$s" class="widget %2$s">',
			'after_widget'  => '</section>',
			'before_title'  => '<h2 class="widget-title">',
			'after_title'   => '</h2>',
		)
	);

	register_sidebar(
		array(
			'name'          => esc_html__( 'Footer 1', 'health-coach-services' ),
			'id'            => 'footer-1',
			'description'   => esc_html__( 'Add widgets here.', 'health-coach-services' ),
			'before_widget' => '<section id="%1$s" class="widget %2$s">',
			'after_widget'  => '</section>',
			'before_title'  => '<h2 class="widget-title">',
			'after_title'   => '</h2>',
		)
	);

	register_sidebar(
		array(
			'name'          => esc_html__( 'Footer 2', 'health-coach-services' ),
			'id'            => 'footer-2',
			'description'   => esc_html__( 'Add widgets here.', 'health-coach-services' ),
			'before_widget' => '<section id="%1$s" class="widget %2$s">',
			'after_widget'  => '</section>',
			'before_title'  => '<h2 class="widget-title">',
			'after_title'   => '</h2>',
		)
	);

	register_sidebar(
		array(
			'name'          => esc_html__( 'Footer 3', 'health-coach-services' ),
			'id'            => 'footer-3',
			'description'   => esc_html__( 'Add widgets here.', 'health-coach-services' ),
			'before_widget' => '<section id="%1$s" class="widget %2$s">',
			'after_widget'  => '</section>',
			'before_title'  => '<h2 class="widget-title">',
			'after_title'   => '</h2>',
		)
	);
}
add_action( 'widgets_init', 'health_coach_services_widgets_init' );


function health_coach_services_social_menu()
    {
        if (has_nav_menu('social-menu')) :
            wp_nav_menu(array(
                'theme_location' => 'social-menu',
                'container' => 'ul',
                'menu_class' => 'social-menu menu',
                'menu_id'  => 'menu-social',
            ));
        endif;
    }


/**
 * Enqueue scripts and styles.
 */

function health_coach_services_scripts() {
    // Google Fonts
    $query_args = array(
        'family' => 'Playfair+Display:wght@0,400;0,500;0,600;0,700;0,800;0,900;1,400;1,500;1,600;1,700;1,800;1,900',
        'display' => 'swap',
    );
    wp_enqueue_style('health-coach-services-google-fonts', add_query_arg($query_args, 'https://fonts.googleapis.com/css'), array(), null);

    // Font Awesome CSS
    wp_enqueue_style('font-awesome-6', get_template_directory_uri() . '/revolution/assets/vendors/font-awesome-6/css/all.min.css', array(), '6.7.2');

    // Owl Carousel CSS
    wp_enqueue_style('owl-carousel-style', get_template_directory_uri() . '/revolution/assets/css/owl.carousel.css', array(), '2.3.4');

    // Wow script.
	wp_enqueue_script( 'wow-jquery', get_template_directory_uri() . '/revolution/assets/js/wow.js', array('jquery'),'' ,true );
	// Animate CSS
	wp_enqueue_style( 'animate-style', get_template_directory_uri() . '/revolution/assets/css/animate.css' );
    
    // Main stylesheet
    wp_enqueue_style('health-coach-services-style', get_stylesheet_uri(), array(), wp_get_theme()->get('Version'));

    // Check if custom styles exist before adding inline styles
    if (file_exists(get_parent_theme_file_path('/custom-style.php'))) {
        require get_parent_theme_file_path('/custom-style.php');

        if (!empty($health_coach_services_custom_css)) {
            wp_add_inline_style('health-coach-services-style', $health_coach_services_custom_css);
        }
    }

    // RTL styles if needed
    wp_style_add_data('health-coach-services-style', 'rtl', 'replace');

    // Navigation script
    wp_enqueue_script('health-coach-services-navigation', get_template_directory_uri() . '/js/navigation.js', array(), wp_get_theme()->get('Version'), true);

    // Owl Carousel script
    wp_enqueue_script('owl-carousel-jquery', get_template_directory_uri() . '/revolution/assets/js/owl.carousel.js', array('jquery'), '2.3.4', true);

    // Custom script
    wp_enqueue_script('health-coach-services-custom-js', get_template_directory_uri() . '/revolution/assets/js/custom.js', array('jquery'), wp_get_theme()->get('Version'), true);

    // Comments reply script
    if (is_singular() && comments_open() && get_option('thread_comments')) {
        wp_enqueue_script('comment-reply');
    }
}
add_action('wp_enqueue_scripts', 'health_coach_services_scripts');

if (!function_exists('health_coach_services_related_post')) :
    /**
     * Display related posts from same category
     *
     */

    function health_coach_services_related_post($post_id){        
        $health_coach_services_categories = get_the_category($post_id);
        if ($health_coach_services_categories) {
            $health_coach_services_category_ids = array();
            $health_coach_services_category = get_category($health_coach_services_category_ids);
            $health_coach_services_categories = get_the_category($post_id);
            foreach ($health_coach_services_categories as $health_coach_services_category) {
                $health_coach_services_category_ids[] = $health_coach_services_category->term_id;
            }
            $health_coach_services_count = $health_coach_services_category->category_count;
            if ($health_coach_services_count > 1) { ?>

         	<?php
		$health_coach_services_related_post_wrap = absint(get_theme_mod('health_coach_services_enable_related_post', 1));
		if($health_coach_services_related_post_wrap == 1){ ?>
                <div class="related-post">
                    
                    <h2 class="post-title"><?php esc_html_e(get_theme_mod('health_coach_services_related_post_text', __('Related Post', 'health-coach-services'))); ?></h2>
                    <?php
                    $health_coach_services_cat_post_args = array(
                        'category__in' => $health_coach_services_category_ids,
                        'post__not_in' => array($post_id),
                        'post_type' => 'post',
                        'posts_per_page' =>  get_theme_mod( 'health_coach_services_related_post_count', '3' ),
                        'post_status' => 'publish',
						'orderby'           => 'rand',
                        'ignore_sticky_posts' => true
                    );
                    $health_coach_services_featured_query = new WP_Query($health_coach_services_cat_post_args);
                    ?>
                    <div class="rel-post-wrap">
                        <?php
                        if ($health_coach_services_featured_query->have_posts()) :

                        while ($health_coach_services_featured_query->have_posts()) : $health_coach_services_featured_query->the_post();
                            ?>

                            <div class="card-item rel-card-item">
								<div class="card-content">
                                    <?php if ( has_post_thumbnail() ) { ?>
                                        <div class="card-media">
                                            <?php health_coach_services_post_thumbnail(); ?>
                                        </div>
                                    <?php } else {
                                        // Fallback default image
                                        $health_coach_services_default_post_thumbnail = get_template_directory_uri() . '/revolution/assets/images/slider1.png';
                                        echo '<img class="default-post-img" src="' . esc_url( $health_coach_services_default_post_thumbnail ) . '" alt="' . esc_attr( get_the_title() ) . '">';
                                    } ?>
									<div class="entry-title">
										<h3>
											<a href="<?php the_permalink() ?>">
												<?php the_title(); ?>
											</a>
										</h3>
									</div>
									<div class="entry-meta">
                                        <?php
                                        health_coach_services_posted_on();
                                        health_coach_services_posted_by();
                                        ?>
                                    </div>
								</div>
							</div>
                        <?php
                        endwhile;
                        ?>
                <?php
                endif;
                wp_reset_postdata();
                ?>
                </div>
                <?php } ?>
                <?php
            }
        }
    }
endif;
add_action('health_coach_services_related_posts', 'health_coach_services_related_post', 10, 1);

function health_coach_services_sanitize_choices( $health_coach_services_input, $health_coach_services_setting ) {
    global $wp_customize; 
    $health_coach_services_control = $wp_customize->get_control( $health_coach_services_setting->id ); 
    if ( array_key_exists( $health_coach_services_input, $health_coach_services_control->choices ) ) {
        return $health_coach_services_input;
    } else {
        return $health_coach_services_setting->default;
    }
}

//Excerpt 
function health_coach_services_excerpt_function($health_coach_services_excerpt_count = 35) {
    $health_coach_services_excerpt = get_the_excerpt();
    $health_coach_services_text_excerpt = wp_strip_all_tags($health_coach_services_excerpt);
    $health_coach_services_excerpt_limit = (int) get_theme_mod('health_coach_services_excerpt_limit', $health_coach_services_excerpt_count);
    $health_coach_services_words = preg_split('/\s+/', $health_coach_services_text_excerpt); 
    $health_coach_services_trimmed_words = array_slice($health_coach_services_words, 0, $health_coach_services_excerpt_limit);
    $health_coach_services_theme_excerpt = implode(' ', $health_coach_services_trimmed_words);

    return $health_coach_services_theme_excerpt;
}

// Add admin notice
function health_coach_services_admin_notice() { 
    global $pagenow;
    $health_coach_services_theme_args      = wp_get_theme();
    $health_coach_services_meta            = get_option( 'health_coach_services_admin_notice' );
    $name            = $health_coach_services_theme_args->__get( 'Name' );
    $health_coach_services_current_screen  = get_current_screen();

    if( !$health_coach_services_meta ){
	    if( is_network_admin() ){
	        return;
	    }

	    if( ! current_user_can( 'manage_options' ) ){
	        return;
	    } 
		
		if( $health_coach_services_current_screen->base !== 'appearance_page_health_coach_services_guide' && 
            $health_coach_services_current_screen->base !== 'toplevel_page_healthcoachservices-demoimport' ) { ?>

            <div class="notice notice-success health-coach-services-welcome-notice">
                <p class="health-coach-services-dismiss-link">
                    <strong>
                        <a href="<?php echo esc_url( add_query_arg( 'health_coach_services_admin_notice', '1' ) ); ?>">
                            <?php esc_html_e( 'Dismiss', 'health-coach-services' ); ?>
                        </a>
                    </strong>
                </p>

                <div class="health-coach-services-welcome-notice-wrap">
                    <h2 class="health-coach-services-notice-title">
                        <span class="dashicons dashicons-admin-home"></span> 
                        <?php 
                            $health_coach_services_theme_name = wp_get_theme()->get( 'Name' );
                            /* translators: %s!: Theme Name. */
                            echo esc_html( sprintf( __( 'Welcome to the free theme: %s!', 'health-coach-services' ), $health_coach_services_theme_name ) );
                        ?>
                    </h2>
                    <p class="health-coach-services-notice-desc">
                        <?php esc_html_e( 'Get started by exploring the features of your new theme. Customize your design, add your content, and create a site that fits your vision.', 'health-coach-services' ); ?>
                    </p>

                    <div class="health-coach-services-welcome-info">
                        <div class="health-coach-services-welcome-thumb">
                            <img src="<?php echo esc_url( get_stylesheet_directory_uri() . '/screenshot.png' ); ?>" alt="<?php esc_attr_e( 'Theme Screenshot', 'health-coach-services' ); ?>">
                        </div>

                        <div class="health-coach-services-welcome-import">
                            <h3><span class="dashicons dashicons-download"></span> <?php esc_html_e( 'Quick Start: Import Demo', 'health-coach-services' ); ?></h3>
                            <p><?php esc_html_e( 'Use the Demo Importer to quickly set up your site with a pre-made layout. Get a complete site in minutes.', 'health-coach-services' ); ?></p>
                            <p><a class="button info-link button-primary" href="<?php echo esc_url( admin_url( 'themes.php?page=healthcoachservices-demoimport' ) ); ?>"><?php esc_html_e( 'Go to Demo Importer', 'health-coach-services' ); ?></a></p>
                        </div>

                        <div class="health-coach-services-welcome-getting-started">
                            <h3><span class="dashicons dashicons-art"></span> <?php esc_html_e( 'Customize Your Theme', 'health-coach-services' ); ?></h3>
                            <p><?php esc_html_e( 'Want to make it truly yours? Explore the Getting Started Guide to personalize your site to suit your needs.', 'health-coach-services' ); ?></p>
                            <p><a class="info-link button" href="<?php echo esc_url( admin_url( 'themes.php?page=health-coach-services-getstart-page' ) ); ?>"><?php esc_html_e( 'View Getting Started Guide', 'health-coach-services' ); ?></a></p>
                        </div>
                    </div>
                </div>
            </div>

            <?php
        }

	}
}

add_action( 'admin_notices', 'health_coach_services_admin_notice' );

if( ! function_exists( 'health_coach_services_update_admin_notice' ) ) :
/**
 * Updating admin notice on dismiss
*/
function health_coach_services_update_admin_notice(){
    if ( isset( $_GET['health_coach_services_admin_notice'] ) && $_GET['health_coach_services_admin_notice'] = '1' ) {
        update_option( 'health_coach_services_admin_notice', true );
    }
}
endif;
add_action( 'admin_init', 'health_coach_services_update_admin_notice' );


add_action('after_switch_theme', 'health_coach_services_setup_options');
function health_coach_services_setup_options () {
    update_option('health_coach_services_admin_notice', FALSE );
}

/**
 * Checkbox sanitization callback example.
 *
 * Sanitization callback for 'checkbox' type controls. This callback sanitizes `$checked`
 * as a boolean value, either TRUE or FALSE.
 */
function health_coach_services_sanitize_checkbox($checked)
{
    // Boolean check.
    return ((isset($checked) && true == $checked) ? true : false);
}

/**
 * Implement the Custom Header feature.
 */
require get_template_directory() . '/revolution/inc/custom-header.php';

/**
 * Custom template tags for this theme.
 */
require get_template_directory() . '/revolution/inc/template-tags.php';

/**
 * Functions which enhance the theme by hooking into WordPress.
 */
require get_template_directory() . '/revolution/inc/template-functions.php';

/**
 * Customizer additions.
 */
require get_template_directory() . '/revolution/inc/customizer.php';

/**
 * Breadcrumb File.
 */
require get_template_directory() . '/revolution/inc/breadcrumbs.php';


/**
 * Custom typography options for this theme.
 */
require get_template_directory() . '/revolution/inc/typography-options.php';


//////////////////////////////////////////////   Function for Translation Error   //////////////////////////////////////////////////////
function health_coach_services_enqueue_function() {
    
    /**
    * GET START.
    */
    require get_template_directory() . '/getstarted/health_coach_services_about_page.php';

    /**
    * DEMO IMPORT.
    */
    require get_template_directory() . '/demo-import/health_coach_services_config_file.php';

    define('HEALTH_COACH_SERVICES_FREE_SUPPORT',__('https://www.revolutionwp.com/products/free-health-coach-wordpress-theme','health-coach-services'));
    define('HEALTH_COACH_SERVICES_PRO_SUPPORT',__('https://www.revolutionwp.com/pages/community/','health-coach-services'));
    define('HEALTH_COACH_SERVICES_REVIEW',__('https://wordpress.org/support/theme/health-coach-services/reviews/#new-post','health-coach-services'));
    define('HEALTH_COACH_SERVICES_BUY_NOW',__('https://www.revolutionwp.com/products/coach-wordpress-theme','health-coach-services'));
    define('HEALTH_COACH_SERVICES_LIVE_DEMO',__('https://demo.revolutionwp.com/health-coach-services-pro/','health-coach-services'));
    define('HEALTH_COACH_SERVICES_PRO_DOC',__('https://demo.revolutionwp.com/wpdocs/health-coach-services-pro/','health-coach-services'));
    define('HEALTH_COACH_SERVICES_LITE_DOC',__('https://demo.revolutionwp.com/wpdocs/health-coach-services-free/','health-coach-services'));
    
}
add_action( 'after_setup_theme', 'health_coach_services_enqueue_function' );


/**
 * Load Jetpack compatibility file.
 */
if ( defined( 'JETPACK__VERSION' ) ) {
	require get_template_directory() . '/revolution/inc/jetpack.php';

}

function health_coach_services_remove_customize_register() {
    global $wp_customize;

    $wp_customize->remove_setting( 'display_header_text' );
    $wp_customize->remove_control( 'display_header_text' );

}

add_action( 'customize_register', 'health_coach_services_remove_customize_register', 11 );

/************************************************************************************/
// //////////////////////////////////////////////

/**
 * WooCommerce custom filters
 */
add_filter('loop_shop_columns', 'health_coach_services_loop_columns');

if (!function_exists('health_coach_services_loop_columns')) {

	function health_coach_services_loop_columns() {

		$health_coach_services_columns = get_theme_mod( 'health_coach_services_per_columns', 3 );

		return $health_coach_services_columns;
	}
}

/************************************************************************************/

add_filter( 'loop_shop_per_page', 'health_coach_services_per_page', 20 );

function health_coach_services_per_page( $health_coach_services_cols ) {

  	$health_coach_services_cols = get_theme_mod( 'health_coach_services_product_per_page', 9 );

	return $health_coach_services_cols;
}

/************************************************************************************/

add_filter( 'woocommerce_output_related_products_args', 'health_coach_services_products_args' );

function health_coach_services_products_args( $health_coach_services_args ) {

    $health_coach_services_args['posts_per_page'] = get_theme_mod( 'custom_related_products_number', 6 );

    $health_coach_services_args['columns'] = get_theme_mod( 'custom_related_products_number_per_row', 3 );

    return $health_coach_services_args;
}

/************************************************************************************/

/**
 * Custom logo
 */

function health_coach_services_custom_css() {
?>
	<style type="text/css" id="custom-theme-colors" >
        :root {
           
            --health_coach_services_logo_width: <?php echo absint(get_theme_mod('health_coach_services_logo_width')); ?> ;   
        }
        .site-branding img {
            max-width:<?php echo esc_html(get_theme_mod('health_coach_services_logo_width')); ?>px ;    
        }         
	</style>
<?php
}
add_action( 'wp_head', 'health_coach_services_custom_css' );

function get_changelog_from_readme() {
    $health_coach_services_file_path = get_template_directory() . '/readme.txt'; // Adjust path if necessary

    if (file_exists($health_coach_services_file_path)) {
        $health_coach_services_content = file_get_contents($health_coach_services_file_path);

        // Extract changelog section
        $health_coach_services_changelog_start = strpos($health_coach_services_content, "== Changelog ==");
        $health_coach_services_changelog = substr($health_coach_services_content, $health_coach_services_changelog_start);

        // Split changelog into versions
        preg_match_all('/\*\s([\d\.]+)\s-\s(.+?)\n((?:\t-\s.+?\n)+)/', $health_coach_services_changelog, $health_coach_services_matches, PREG_SET_ORDER);
        
        return $health_coach_services_matches;
    }
    return [];
}

function health_coach_services_custom_css_for_slider() {
    $health_coach_services_slider_enabled = get_theme_mod('health_coach_services_enable_slider', false);
    if ($health_coach_services_slider_enabled) {
        echo '<style type="text/css">
            .page-template-revolution-home .headermain {
                position: absolute !important;
                width: 100% !important;
                z-index: 999 !important;
                background: transparent !important;
                border: none !important;
            }
            .page-template-revolution-home .menucontent {
                background: rgba(5, 83, 70, 0.5) !important;
            }
        </style>';
    }
}
add_action('wp_head', 'health_coach_services_custom_css_for_slider');